package dw.samples.ldapcontrols;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.NamingException;
import javax.naming.directory.Attribute;
import javax.naming.directory.Attributes;
import javax.naming.directory.InitialDirContext;

/**
 * Prints out all supported controls of an LDAP v3 Server.
 * 
 * developerWorks, Take advantage of IBM Tivoli Directory Server's LDAP Controls
 * via Java and JNDI, Listing 2: Examine controls supported by an LDAP server
 * (JNDI version).
 * 
 * @author Stefan Zoerner
 */
public class ShowSupportedControls {

    public static void main(String[] args) throws NamingException {

        Hashtable env = new Hashtable();
        env.put(Context.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.ldap.LdapCtxFactory");
        env.put(Context.PROVIDER_URL, "ldap://magritte:389/");

        InitialDirContext ctx = new InitialDirContext(env);
        Attributes attrs = ctx.getAttributes("", new String[] { "supportedcontrol" });

        Attribute attr = attrs.get("supportedcontrol");
        for (int i = 0; i < attr.size(); ++i) {
            System.out.println(attr.getID() + "=" + attr.get(i));
        }
    }
}