package dw.samples.ldapcontrols;

import java.io.IOException;
import java.io.InputStream;

import netscape.ldap.ber.stream.BERElement;
import netscape.ldap.ber.stream.BERSequence;
import netscape.ldap.ber.stream.BERTagDecoder;

/**
 * Specific BER Tag decoder class. Note that Netscape Directory SDK for Java is
 * necessary to compile and run the example.
 * 
 * developerWorks, Take advantage of IBM Tivoli Directory Server's LDAP Controls
 * via Java and JNDI.
 * 
 * @author Stefan Zoerner
 */
class SpecificTagDecoder extends BERTagDecoder {

    public BERElement getElement(BERTagDecoder decoder, int tag, InputStream stream,
            int[] bytes_read, boolean[] implicit) throws IOException {

        BERElement element = new BERSequence(decoder, stream, bytes_read);
        implicit[0] = false;

        return element;
    }
}