package dw.samples.ldapcontrols;

import javax.naming.NamingException;
import javax.naming.ldap.Control;
import javax.naming.ldap.InitialLdapContext;
import javax.naming.ldap.LdapContext;

/**
 * Sample use of the Tree Delete Control.
 * 
 * Simple main program to delete an entry and its children with the help of the
 * TreeDeleteControl class.
 * 
 * developerWorks, Take advantage of IBM Tivoli Directory Server's LDAP Controls
 * via Java and JNDI, Listing 4: Use of the Tree Delete Control.
 * 
 * @author Stefan Zoerner
 */
public class TestTreeDeleteControl {

    public static void main(String[] args) throws NamingException {

        LdapContext ctx = new InitialLdapContext();

        LdapContext entry = (LdapContext) ctx.lookup("ou=subtree");
        entry.setRequestControls(new Control[] { new TreeDeleteControl() });
        entry.unbind("");
    }
}